#include "fpp.h"
#include "hash.h"

#if STDC
void
dodef2(const char *thename, const char *thevalue, int permanent)
#else /* NOT STDC */
void
dodef2(thename,thevalue,permanent)
const char *thename;
const char *thevalue;
int permanent;				/* 1 if permanent */
#endif /* STDC */
{
    int n;

    if (PERMANENT(thename) && !permanent)
    {
	SPRINTF(err_line,"Permanent symbol %s cannot be redefined",thename);
	error(err_line,0);
	return;
    }

    n = install(thename,thevalue);

    if (fpp_debug)
    {
	FPRINTF(stddbg,"DEBUG: Macro: %s=%s\n",thename,thevalue);
	FFLUSH(stddbg);
    }

    if (!PERMANENT(thename))
	PRINTF("%s Macro: %s=%s\n",OUT_PREFIX,thename,thevalue);

    if (n < 0)
	error("Too many defined symbols",0);
}
